; (c)Vladimir K.
; site: www.palmgames.narod.ru
; mail: palmgames@gala.net
;
; SPBall.asm -- 
; 
;:
; -      - 
;	  ,   
; - ... -  -
;	 divu	d0, d3    d3   
; -     :
;	call MySub(PointType.x.Coord(a5).w)
;	      :
;		move.w	PointType.x.Coord(a5),d1
;		call 	MySub(d1.w)
;------------------------------------------------------
; -   \     
;	:       
;	  ,   , :
;	   (  ) ,
;	  ,    :
;	proc MyProc(val.w)
;	...
;	move	val(a6),d2
;	call	MyProc2(d2.b)
;	move.b	d2,d3	
;	...
;	endproc
;
;	:
;	call	MyProc2(val(a6).b)
;	move.b	val(a6),b3	
;------------------------------------------------------




;	appl	"SpokeBall", '_B2_'
	appl	"SpBall", 'B2pi'

	include	"Pilot.inc"

	include	"Startup.inc"

;idrHelpString	equ	1001

idrPREF		equ	1
idrTVER		equ	1

idrAIB     	equ 1000
idrForm		equ 1000
idrAlert	equ 1000
idrAlAbout	equ 1001 ;alert about
idrButton	equ 1001
idrMenu		equ 1000
idmRule 	equ 1001
idmAbout	equ 1002

idbmBar		equ 200
idbmBarClear equ 201

idbmBall	equ 400
idRed		equ 0
idGreen		equ 1
idBlue		equ 2
idYellow	equ 3
idViolet	equ 4

idbmShadow	equ 500

; /    
pan_x		equ 4
pan_y		equ 147
; -   
pan_dx		equ 13

;    
tab_x		equ 4
tab_y		equ 6
; 
diam		equ 10

tab_ww		equ 14
tab_hh		equ 12
tab_wh		equ tab_hh*tab_ww
;
struct Prefs
	lost.w
	field.168 ;14*12
	panel.10 ;5*2
	selind.w
endstruct ;182




align
	data

bmBar	dc.l	0
hbmBar	dc.l	0
bmBall	dc.l	0,0,0,0,0
hbmBall dc.l	0,0,0,0,0
bmShadow  dc.l	0
hbmShadow dc.l	0

;      
ptrTab	dc.l	0
; 
tab_w	dc.w	tab_ww ;14
tab_h	dc.w	tab_hh ;11

;      /
;: x.b, y.b
ptrBalls	dc.l	0
;  
BallsCounter	dc.w	0
;  
LostCount	dc.w	0


seli	dc.w	0 ;  
global	selpt.PointType ;   
;   
selcolor dc.w	0,1,2,3,4

global	pScr.l ;   

;   
global	string.32
global	strvar.l


;   
;global	buf.32
;global	var.l

;
strLost	dc	'LOST:',0

	code

proc PilotMain (cmd.w, cmdPBP.l, launchFlags.w)	
beginproc ;   -  link

	tst.w	cmd(a6)		;sysAppLaunchCmdNormalLaunch is 0
	bne	PmReturn		;not a normal launch, bag out

	systrap FrmGotoForm(#idrForm.w)
	call EventLoop()
	call AppExit()
endproc

proc EventLoop ()
	local   evt.EventType
	local	err.w			; neither of these locals are used in this example
beginproc

PmEventLoop:
; Doze until an event arrives
	systrap EvtGetEvent(&evt(a6), #evtWaitForever.w)
; System gets first chance to handle the event
	systrap SysHandleEvent(&evt(a6))
	tst.b   d0                      ;handled?
	bne.s   PmEventDone             ;yep
; Menu handler gets second chance to handle the event
	systrap MenuHandleEvent(&0, &evt(a6), &err(a6))
    tst.b   d0                      ;handled?
    bne.s   PmEventDone             ;yep
; Application handler gets third chance to handle the event
    call    ApplicationHandleEvent(&evt(a6))
    tst.b   d0                      ;handled?
    bne.s   PmEventDone             ;yep
; Form handler gets fourth chance to handle the event
    call    MainFormHandleEvent(&evt(a6))
    tst.b   d0                      ;handled?
    bne.s   PmEventDone             ;yep
; Still not handled. We're not interested in it anymore so let the
; default form handler take it.
    systrap FrmGetActiveForm()
    systrap FrmHandleEvent(a0.l, &evt(a6))

; Return from PilotMain when an appStopEvent is received
PmEventDone
	cmpi.w  #appStopEvent,evt+EventType.eType(a6) ;time to stop?
    bne.s  	PmEventLoop             ;nope, loop until it is

PmReturn
    moveq   #0,d0

endproc

proc AppExit ()
beginproc
	;-   --------
	tst.l	bmBar(a5)
	beq		clvar_1
	;table
	SysTrap MemPtrFree(ptrTab(a5).l)
	;array
	SysTrap MemPtrFree(ptrBalls(a5).l)
	;
	systrap MemHandleUnlock(hbmBar(a5).l)
	systrap DmReleaseResource(hbmBar(a5).l)
	;
	systrap MemHandleUnlock(hbmShadow(a5).l)
	systrap DmReleaseResource(hbmShadow(a5).l)
	;-    -
	move.w	#idViolet,d3
	lpclball:
	;  4 
	move.w	d3,d4
	asl.w	#2,d4
	;  
	move.l	hbmBall(a5,d4.w),a4
	;  
	systrap MemHandleUnlock(a4.l)
	systrap DmReleaseResource(a4.l)
	; addq	#1,d3
	; cmp		#idViolet,d3
	dble.w	d3,lpclball
	; 
	SysTrap WinPalette(#2.b, #0.w, #(255).w, #0.l);
	;-----------------------------
clvar_1:

	sysTrap FrmSaveAllForms()
	sysTrap	FrmCloseAllForms()
endproc

; ---------------------------------------------------------------------------
; Boolean ApplicationHandleEvent(EventType *pevt)
; Handles these events:
;       frmLoadEvent
proc ApplicationHandleEvent(pevt.l)
beginproc
    movem.l a3,-(a7)                ;save registers we're going to trash
    movea.l pevt(a6),a0             ;a0 = pevt

; Handle frmLoadEvents

    cmpi.w  #frmLoadEvent,EventType.eType(a0) ;frmLoadEvent?
    bne     AHENotHandled           ;no

; Initialize the form and make it active
    systrap FrmInitForm(EventType.data+frmLoad.formID(a0).w)
    systrap FrmSetActiveForm(a0.l)
	; . . :

	;   
	clr.l	d0
	move.w	tab_w(a5),d0
	mulu	tab_h(a5),d0
	move	d0,d4
	asl		#1,d4
	SysTrap MemPtrNew(d0.l)
	move.l	a0,ptrTab(a5)
	; 
	call	FillTable()
	;    
	SysTrap MemPtrNew(d4.l)
	move.l	a0,ptrBalls(a5)


	;   
	systrap	WinGetDrawWindow()
	SysTrap WinGetBitmap(a0.l)
	systrap BmpGetBits(a0.l)
	;    
	move.l	a0,pScr(a5)

	;   
	move.l	#'Tbmp',d4
	systrap DmGetResource(d4.l, #idbmBar.w)
	move.l	a0,hbmBar(a5) ;handle to res
	beq		init_end ;  
	systrap	MemHandleLock(a0.l)
	move.l	a0,bmBar(a5) ;save BitmapPtr
	;SysTrap BmpCompress(a0.l,#$ff.b) ;uncompress bitmap
	;tst.b	d0
	;beq		init_end ;no error
	;move.l	#0,bmBar(a5) ;

	;  
	systrap DmGetResource(d4.l, #idbmShadow.w)
	move.l	a0,hbmShadow(a5) ;handle to res
	beq		init_end ;  
	systrap	MemHandleLock(a0.l)
	move.l	a0,bmShadow(a5) ;save BitmapPtr

	;load balls pictures
	;d5- aligned index
	;d4- rezerved "Tbmp"
	;d3- counter
	;d6- id to res
	move.w	#idViolet,d3
	lpldballs:
	move.w	d3,d5
	asl.w	#2,d5 ;d3*2
	move.w	#idbmBall,d6
	add		d3,d6 ;idBalls+d3
	systrap DmGetResource(d4.l, d6.w)	
	move.l	a0,hbmBall(a5,d5.w) ;handle
	beq		init_end ;  
	systrap	MemHandleLock(a0.l)
	move.l	a0,bmBall(a5,d5.w) ;save BitmapPtr
	dble.w	d3,lpldballs

	;-----------------------------
init_end:
    moveq.l #1,d0                   ;event handled
    bra.s   AHEReturn
;----------------------
AHENotHandled
	clr.b   d0

AHEReturn
    movem.l (a7)+,a3
endproc

; ---------------------------------------------------------------------------
; Boolean MainFormHandleEvent(EventType *pevt)
; Handles these events:
;
str000 dc 'MainFormHandleEvent',0

proc MainFormHandleEvent(pevt.l)
;local pForm FormPtr
beginproc

    movea.l pevt(a6),a0             ;a0 = pevt
    move.w  EventType.eType(a0),d0

; Handle frmOpenEvent
	cmp.w	#frmOpenEvent,d0
    bne.s	Events
	call	HEfrmOpen()
    bra		MFHhandled
;--- Events ---------------------------
Events
	cmp.w	#penUpEvent,d0
	dc.w	$6606 ;=bne +6;
	call	HEpenUP()
	bra.s	MFHhandled

	cmp.w	#penDownEvent,d0
	;beq.s	PenDown
	dc.w	$6606 ;=bne +6;    
	call	HEpenDown()
	bra.s	MFHhandled

	cmp.w	#menuEvent,d0
	beq.s	menuHandler
	cmp.w 	#ctlSelectEvent,d0
	beq.s	select
	
	;no Events
MFHnotHandled
    clr.b   d0
	;     :
	;eor.b	d0,d0	;= xor d,d
	bra.s	MFHend 
;----------- Handlers -----------------
menuHandler
    cmp.w   #idmRule, EventType.data+menu.itemID(a0)
    bne     mh_menu2
    systrap FrmAlert(#idrAlert.w)
	bra		mh_end
mh_menu2:
	cmp.w   #idmAbout, EventType.data+menu.itemID(a0)
    bne     MFHnotHandled
    systrap FrmAlert(#idrAlAbout.w)

mh_end:
	;  
	SysTrap WinSetTextColor(#156.b)
	SysTrap WinSetBackColor(#0.b)

	bra.s	MFHhandled

; Handle ctlSelectEvent
select

;Is the convert button being clicked?
	cmp.w   #idrButton,EventType.data+ctlEnter.controlID(a0)
	bne     MFHnotHandled
	;  
	systrap FrmAlert(#idrAlert.w)
	


	;bra.s	MFHhandled
;Pen Down Handler
PenDown
	;bra.s 	MFHhandled

;Pen Up handler
PenUp
	;bra.s 	MFHhandled

MFHhandled
	move.l #1,d0
MFHend
endproc

;-------------- HANDLERS -------------------------------
;         0 - 
; *evt -  
;(.    - MainFormHandleEvent(pevt.l)
;struct EventType
;    eType.w
;    penDown.w
;    screenX.w
;    screenY.w
;    data.16
;endstruct
;
;-------------------------------------------------------
proc HEfrmOpen()
beginproc
	;Draw the form -----------------------
    ;systrap FrmGetActiveForm()
	systrap	FrmGetFormPtr(#idrForm)
	systrap FrmDrawForm(a0.l)
	;     
	SysTrap BmpGetColortable(bmBar(a5).l) ;
	;    
	addq.l	#2,a0
	; 
	SysTrap WinPalette(#1.b, #0.w, #(255).w, a0.l);
	; 
	systrap WinPaintBitmap(bmBar(a5).l, #0.w, #143.w)
	
	; 
	;call DrawBall(#4.w, #147.w, #idRed.w)
	;call DrawBall(#4.w, #146.w, #idRed.w)
	;call DrawBall(#17.w, #147.w, #idGreen.w)
	;call DrawBall(#30.w, #147.w, #idBlue.w)
	;call DrawBall(#43.w, #147.w, #idYellow.w)
	;call DrawBall(#56.w, #147.w, #idViolet.w)
	; 
	;systrap WinPaintBitmap(bmShadow(a5).l, #5.w, #148.w)
	call DrawPanelBalls()
	call DrawTable()

	;  
	SysTrap WinSetTextColor(#156.b)
	SysTrap WinSetBackColor(#0.b)

	; 
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinPaintChars(&buf(a5), d0.w, #40.w, #80.w)
	systrap StrLen(&strLost(a5).l)
	systrap WinDrawChars(&strLost(a5), d0.w, #82.w, #146.w)
	clr.l	d0
	move	tab_h(a5),d0
	mulu	tab_w(a5),d0
	move	d0,LostCount(a5)
	;uses a0 d0, you must store this before
	move.l	d0,strvar(a5)
	systrap StrIToA(&string(a5).l,strvar(a5).l)
	systrap StrLen(&string(a5).l)
	systrap WinDrawChars(&string(a5).l, d0.w, #110.w, #146.w)
	

endproc	

proc HEpenDown()
;local	posX.w
;local	posY.w
;!!! -   boolean - ,    
;local	posDown.w ;boolean 
beginproc
	
	;systrap FrmAlert(#idrAlert.w)
	;  

	;----
	;  
	move.l	pScr(a5),a1
	;systrap WinGetDrawWindow()
	;SysTrap WinGetBitmap(a0.l)
	;systrap BmpGetBits(a0.l)

	move.l	#80,d0  ;Y
	mulu.w	#160,d0
	add.w	#$30,d0 ;X
	add.l	d0,a1

	;move.w	EventType.screenY(a0),d0 ;Y
	;mulu.w	#160,d0
	;add.w	EventType.screenX(a0),d0 ;X
	;add.l	d0,a1

	move.w	#31,d1 ;. 
	move.w	#160,d0 ;   
pd_fillcol:
	move.w	#31,d2 ;. 
	move.l  a1,a2 ;   
pd_fillrow:
;	move.b	#193,(a2)+ ;  193   
	dbf		d2,pd_fillrow
	adda	d0,a1 ;  .
	dbf		d1,pd_fillcol

;	clr.l	d0
;	call	GetCell(#0.w, #0.w)
;	;move	#1,d0
;	move.l	d0,var(a5)
;	;uses a0 d0, you must store this before
;	move.l	a0,a4
;	systrap StrLen(&buf(a5).l)
;	systrap WinEraseChars(&buf(a5),d0.w, #40.w, #100.w)
;	systrap StrIToA(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #40.w, #100.w)
;	move.l	a4,a0
	
	;move.l	a0,a4
	;call DrawTable()
	;move.l	a4,a0
	
	;   
	;  
	call	GetSelCoord(EventType.screenX(a0).w, EventType.screenY(a0).w)
	tst		d0

	;beq		pd_cpan
	;      , 
	beq		pd_cx_end

	call	SwapBalls()
	bra		pd_cx_end		
	
pd_cpan:
	;   
	;SysTrap EvtGetPen(&posX(a6), &posY(a6), &posDown(a6))
;	clr.l	d7
;	move.w	EventType.screenY(a0),d7
;	sub.w	#pan_y,d7 ;calc pos in [pan_y..(pan_y+diam)]
;	cmp.w	#(diam+pan_y),d7
;	bhi		pd_cx_end ;if not in[pan_y..(pan_y+diam)] then exit
;	move.w	EventType.screenX(a0),d6
;	sub.w	#pan_x,d6
;	clr.w	d0
;	clr.w	d1
;pd_cx:
;	cmp		#diam,d6
;	bhi.s	pd_cx_next
;	move.w	seli(a5),d1
;	call	ClearPanelBall(d1.w)
;	move.w	d0,seli(a5)
;	call	DrawPanelBalls()
;	bra.s	pd_cx_end
;pd_cx_next:
;	sub.w	#pan_dx,d6
;	addq.w	#1,d0
;	cmp.w	#4,d0 ; ball count-1
;	ble		pd_cx
pd_cx_end:	

endproc

str dc 'Label',0

proc HEpenUP()
beginproc
	;systrap FrmAlert(#idrAlert.w)
endproc

;-------------- USER ROUTINES --------------------------
;----------------------------
proc DrawBall(x.w, y.w, id.w)
beginproc
	move id(a6),d0
	cmp.b	#idViolet,d0
	bls		db_draw
db_clear:
	call	DrawFillRect(x(a6).w, y(a6).w, #(diam).w, #(diam).w, #0.b)	
	bra	db_end
db_draw:
	asl	#2,d0
	move.l bmBall(a5,d0.w),a0
	systrap WinPaintBitmap(a0.l, x(a6).w, y(a6).w)
	;systrap WinDrawBitmap(a0.l, x(a6).w, y(a6).w)
db_end:
endproc

;--------------------
proc DrawPanelBalls()
beginproc
	movem 	d0-d6,-(a7) ; 
	move	#pan_x,d5 ; x-pos
	move	d5,d6 ;store
	move    #pan_dx,d4 ;inc on X
	clr		d3 ;balls counter (index)
;draw balls
dp_n:
	;asl		#1,d3
	move	selcolor(a5,d3),d2	
	call 	DrawBall(d5.w,#pan_y.w,d2.w)
	add		d4,d5
	addq	#2,d3	; 2     -2 
	cmp		#8,d3 ;end ball*2-1
	ble.s	dp_n
;draw shadow
	move.w	seli(a5),d3
	move	d3,d5
	asl		#1,d3
	move	selcolor(a5,d3),d2 
	mulu	d4,d5
	add		d5,d6
	call	ClearPanelBall(seli(a5).w)
	call 	DrawBall(d6.w,#(pan_y-1).w,d2.w)
	addq	#1,d6
	systrap WinPaintBitmap(bmShadow(a5).l, d6.w,#(pan_y-(-1)).w)
	movem 	(a7)+,d0-d6 ; 
endproc

;-------------------------
proc ClearPanelBall(ind.w)
beginproc
	movem	d0-d3/a0-a1/a3,-(a7)

	;>>>---
;	move.w	#(pan_y-1),d2  ;Y
	;  
;	move.l	#'Tbmp',d0
;	systrap DmGetResource(d0.l, #idbmBarClear.w)
;	move.l	a0,a3 ;handle to res
;	beq		cb_end ;  
;	systrap	MemHandleLock(a0.l)
	;move.l	a0,bmBar(a5) ;save BitmapPtr
;	systrap WinPaintBitmap(a0.l, d3.w, d2.w)
;	systrap MemHandleUnlock(a3.l)
;	systrap DmReleaseResource(a3.l)
;	cb_end:
	;<<<---

	;---->>>>
;	move	ind(a6),d0
;	mulu	#pan_dx,d0 ;inc on x
;	;move	#0,d0 ;x
;	add		#pan_x,d0
;	subq	#1,d0 ;pos-x sel ball
;	;  
;	move.l	pScr(a5),a0
;	move.w	#(pan_y-1),d1  ;Y
;	mulu.w	#160,d1 ;increment on row
;	add.w	d0,d1 ;X
;	add.l	d1,a0
;
;	move	#(diam+2),d2
;	move	#160,d0
;	move	#193,d1 ; palette clear index
;lp_cp:
;	move	#(diam+2),d3
;	;move	#(pan_dx*5),d3
;	move.l	a0,a1
;lp_cp1:
;	move.b	d1,(a1)+
;	dbf		d3,lp_cp1
;	add		d0,a0
;	dbf		d2,lp_cp
	;<<<<----

	move	ind(a6),d0
	mulu	#pan_dx,d0 ;inc on x
	add		#pan_x,d0
	;subq	#1,d0 ;pos-x sel ball
	move.w	#(pan_y-1),d1  ;Y
	call	DrawFillRect(d0.w, d1.w, #(diam).w, #(diam-(-1)).w, #193.b)	
	
	movem	(a7)+,d0-d3/a0-a1/a3
endproc

;------------------------------------------------
;dx  dy    1 , ..    0    1
proc DrawFillRect(x.w,y.w,dx.w,dy.w,ColorIndex.b)
beginproc
	movem	d0-d3/a0-a1,-(a7)

	;  
	move.l	pScr(a5),a0
	move.w	y(a6),d1  ;Y
	mulu.w	#160,d1 ;increment on row
	add.w	x(a6),d1 ;X
	add.l	d1,a0

	move	dy(a6),d2
	move	#160,d0 ;increment on row
	move.b	ColorIndex(a6),d1 ; palette clear index
df_cp:
	move	dx(a6),d3
	move.l	a0,a1
df_cp1:
	move.b	d1,(a1)+
	dbf		d3,df_cp1
	add		d0,a0
	dbf		d2,df_cp

	movem	(a7)+,d0-d3/a0-a1
endproc

;----------------------------
; :
; d0.b-
; 0.l-  
; .  0
proc GetCell(x.w, y.w)
beginproc
	movem	d1-d4,-(a7)

;	move	y(a6),var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #60.w, #10.w)
;	move.l	x(a6),var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #60.w, #40.w)


	; 
	move	x(a6),d1
	move	tab_w(a5),d3
	cmp.w	d3,d1
	bcc		gc_err
	; Y
	move	y(a6),d2
	move	tab_h(a5),d4
	cmp.w	d4,d2
	bcc		gc_err

	mulu	d3,d2
	add		d1,d2
	move.l	ptrTab(a5),a0
	move.b	0(a0,d2),d0
	;move	#10101,d0
	bra.s	gc_end
gc_err:
	move	#-1,d0
gc_end:
	movem	(a7)+,d1-d4
endproc

;--------------------------------
;   
;   d0-,      
; .  0
lll01 dc 'proc SetCell(x.w, y.w, value.b)',0

proc SetCell(x.w, y.w, value.b)
beginproc
	movem	d1-d4/a0,-(a7)

;	; 
	move	x(a6),d1
	move	tab_w(a5),d3
;	cmp.w	d3,d1
;	bcc		sc_err
;	; Y
	move	y(a6),d2
	move	tab_h(a5),d4
;	cmp.w	d4,d2
;	bcc		sc_err

	mulu	d3,d2
	add		d1,d2
	move.l	ptrTab(a5),a0
;>>>>>>>>>>>>>>>>
;	move.l	a0,a3
;	
;	move.l	a0,var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #4.w, #80.w)
;
;	clr.l	var(a5)
;	move.b	value(a6), var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #60.w, #80.w)
;	
;	move.l	a3,a0
;<<<<<<<<<<<<<<<<
	move.b	0(a0,d2), d0
	move.b	value(a6), 0(a0,d2)
	bra.s	sc_end
sc_err:
	move	#-1,d0
sc_end:
	
	movem	(a7)+,d1-d4/a0
endproc

;------------------------------
proc DrawCell(x.w, y.w)
beginproc
	movem	d1/d2,-(a7)

	call	GetCell(x(a6).w, y(a6).w)
	move	x(a6), d1
	move	y(a6), d2
	mulu	#(diam+1), d2
	mulu	#(diam+1), d1
	add		#tab_y, d2
	add		#tab_x, d1 
	call	DrawBall(d1.w, d2.w, d0.w)
	movem	(a7)+,d1/d2
endproc

;------------------------------
proc DrawTable()
beginproc
	movem	d1/d2,-(a7)
	clr		d2 ;y
dt_y:	
	clr		d1 ;x
dt_x:
	;call	GetCell(d1.w,d2.w)
	;cmp.b	#idViolet,d0
	;bls		dt_draw
	;move	#idViolet, d0
dt_draw:
	;call	SetCell(d1.w,d2.w,#2.b)
	;move.b	#2,d0
	call	DrawCell(d1.w,d2.w)
	addq	#1,d1
	cmp		tab_w(a5),d1
	bcs		dt_x

	addq	#1,d2
	cmp		tab_h(a5),d2
	bcs		dt_y

	movem	(a7)+,d1/d2
endproc

;------------------------------
proc FillTable()
beginproc
	movem	d0-d4/a0,-(a7)

	; 
	SysTrap TimGetTicks()
	SysTrap SysRandom(d0.l)
	clr		d4 ;y
ft_y:	
	clr		d3 ;x
ft_x:
	SysTrap SysRandom(#0.l)
	;asr.l	#8, d0 ;
	;asr.l	#4, d0
	;sub.l	#3,d0
	divu	#$19EF,d0
	call	SetCell(d3.w, d4.w, d0.b)
	addq	#1,d3
	cmp		tab_w(a5),d3
	bcs		ft_x

	addq	#1,d4
	cmp		tab_h(a5),d4
	bcs		ft_y

	movem	(a7)+,d0-d4/a0
endproc

;------------------------------
;return d0-bool: 1-yep/0-not in range
;      
proc GetSelCoord( x.w, y.w)
beginproc
	movem	d1-d4,-(a7)

	move	#(diam+1), d0
	move	x(a6), d2
	move	y(a6), d4
	; 
	cmp		#tab_x, d2
	bcs		gs_none
	move	d0, d1
	mulu	tab_w(a5), d1
	sub		#tab_x, d2
	cmp		d2, d1
	bls		gs_none
	; Y
	cmp		#tab_y, d4
	bcs		gs_none
	move	d0, d1
	mulu	tab_h(a5), d1
	sub		#tab_y, d4
	cmp		d4, d1
	bls		gs_none
	;d3 = X-tab_x
	;d4 = Y-tab_y
	;d0 = diam+1
	divu	d0, d2
	divu	d0, d4
	;  
	call	GetCell(d2.w, d4.w)
	move	seli(a5),d1
	asl		#1,d1
	move	selcolor(a5,d1),d3
	cmp.b	d3,d0
	beq		gs_none

	move	#1,d0 
	bra		gs_end
	
gs_none:
	move	#-1,d2
	move	d2,d4
	clr		d0
gs_end:	
	move	d2,PointType.x.selpt(a5)
	move	d4,PointType.y.selpt(a5)

	movem	(a7)+,d1-d4
endproc

;------------------------------
proc SwapBalls()
beginproc
	movem	d0-d4,-(a7)

;	move	PointType.y.selpt(a5),var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #60.w, #80.w)
;	move.l	PointType.x.selpt(a5),var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #60.w, #60.w)
	


	move.w	PointType.x.selpt(a5),d3	
	move.w	PointType.y.selpt(a5),d4
	call	GetCell(d3.w, d4.w)

;	move	d0,d3
;	move.l	d3,var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #4.w, #80.w)
;	move 	d3,d0

	cmp.b	#idViolet,d0
	bhi		sb_noSwap
	;swap
	move	seli(a5),d1
	asl		#1,d1
	move	selcolor(a5,d1),d2
	clr		d0
	call	SetCell(d3.w, d4.w, d2.b)
	move	d0,selcolor(a5,d1)

;	move	d0,d3
	move	#0,d1
;	move.l	selcolor(a5,d1),var(a5)
	;move.w	d2,var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #4.w, #80.w)
;	move 	d3,d0

	;inc panel ball index
	move	seli(a5),d1
	call	ClearPanelBall(d1.w)
	addq	#1,d1
	cmp		#idViolet,d1
	bls		sb_SaveSelID
	clr		d1
sb_SaveSelID:
	move	d1,seli(a5)
	
	call	DrawPanelBalls()
	call	DrawCell(d3.w, d4.w)
	call	TableDoIT(d3.w, d4.w)
	bra		sb_end
sb_noSwap:	
sb_end:

	movem	(a7)+,d0-d2
endproc

;------------------------------
proc TableDoIT(x.w, y.w)
beginproc
	movem	d0-d4,-(a7)
	
	move.w	x(a6),d3	
	move.w	y(a6),d4

;	clr.l	d0
;	move.b	d3,d0
;	asl		#8,d0
;	move.b	d4,d0
;	move.l	d0,var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawInvertedChars(&buf(a5), d0.w, #110.w, #146.w)
;
	;get array begin
	;move.l	ptrBalls(a5),a2
;	move.l	a2,var(a5)
;	systrap StrIToH(&buf(a5).l,var(a5).l)
;	systrap StrLen(&buf(a5).l)
;	systrap WinDrawChars(&buf(a5), d0.w, #40.w, #80.w)

	;clr		d5 ;ball's coord counter
	call	CheckFirstRow(d3.w,d4.w)
	cmp		#1,d0
	bls		td_end
	move.w	d0,BallsCounter(a5)
	call	DropBalls()
	clr.l	d0
	move	LostCount(a5),d0
	sub		BallsCounter(a5),d0
	subq	#1,d0
	move	d0,LostCount(a5)
	move.l	d0,strvar(a5)
	systrap StrLen(&string(a5).l)
	systrap WinEraseChars(&string(a5),d0.w, #110.w, #146.w)
	systrap StrIToA(&string(a5).l,strvar(a5).l)
	systrap StrLen(&string(a5).l)
	systrap WinDrawChars(&string(a5), d0.w, #110.w, #146.w)

td_end:
	movem	(a7)+,d0-d4
endproc

;------------------------------
;return-d0.w: 0-no balls or count of balls in row
proc CheckFirstRow(x.w,y.w)
beginproc
	movem	d3-d7/a2,-(a7)

	move	x(a6),d3
	move	y(a6),d4
	call	GetCell(d3.w,d4.w)
	move.b	d0, d5 ;
	clr		d6 ;   
	move.l	ptrBalls(a5),a2

	;   
cfr_left:	
	tst		d3
	beq		cfr_right_1
	subq	#1,d3
	call	GetCell(d3.w,d4.w)
	cmp.b	d0,d5
	beq		cfr_left

	; ,     
cfr_right:
	;  ..    1 
	;   
	addq	#1,d3
cfr_right_1: ;   =0 ..   
	cmp		tab_w(a5),d3
	bcc		cfr_end ;d3>=tab_w
	call	GetCell(d3.w, d4.w)
	cmp.b	d0,d5
	bne		cfr_end
	move	d6,d7
	asl		#1,d7
	move.b	d3, 0(a2,d7) ;store X
	move.b	d4, 1(a2,d7) ;store Y
	addq	#1, d6
	bra		cfr_right

cfr_end:
	subq	#1,d6 ;  ..      
	move	d6,d0
	movem	(a7)+,d3-d7/a2
endproc

;------------------------------
proc DropBalls()
beginproc
	movem	d3-d5/d7/a4,-(a7)

	move.l	ptrBalls(a5),a4
	move	BallsCounter(a5),d7
	clr		d3
	clr		d4
	; 
db_cb:
	move	d7,d5
	asl		#1,d5
	move.b	0(a4,d5),d3
	move.b	1(a4,d5),d4
	call	ClearTableBall(d3.w,d4.w) ;clear ball
	dbf		d7,db_cb
	
	movem	(a7)+,d3-d5/d7/a4
endproc

;------------------------------
proc ClearTableBall(x.w, y.w)
beginproc
	movem	d6-d7,-(a7)

	move	x(a6),d6
	move	y(a6),d7
	call	SetCell(d6.w, d7.w, #-1.w) ;clear ball in table
	mulu	#(diam+1),d6
	mulu	#(diam+1),d7
	add		#tab_x,d6
	add		#tab_y,d7
	call	DrawBall(d6.w, d7.w, #-1.w) ;clear ball	on screen
	
	movem	(a7)+,d6-d7
endproc





;-------------- END USER ROUTINES ----------------------- 


;-------------- RESOURCES ------------------------------
; Form resource
	res 'tFRM', idrForm, "tFRM03e8.bin"

; Application Icon Bitmap resource
	res 'tAIB', idrAIB, "tAIB03e8.bin"

; Alert resource
	res	'Talt', idrAlert, "Talt03e8.bin"
	res	'Talt', idrAlAbout, "Talt03e9.bin"
; Help string resource
;res	'tSTR', idrHelpStr
;dc.b	'I am a Pilot programming stud!', 0

; Version resource
	res	'tver', idrTVER
	;dc.b	'1.0', 0
	dc	'0.1',0

; Menu res
	res 'MBAR', idrMenu, "MBAR03e8.bin"


;!!! - ,    () 
	res 'taic', 1000
		dc	'Demos',0 
; -      ,   ,
; - , ,     
; !!! -     res 'taic'
	res 'tAIN', 1000
	dc	'SpBall',0

; - Bitmaps
	res 'Tbmp', idbmBar, 	"panel00c8.bin"
	res 'Tbmp', idbmShadow,	"shadow01f4.bin"
;	res 'Tbmp', idbmBarClear, "bc00c9.bin"


	res 'Tbmp', idbmBall+idRed, 	"red0190.bin"
	res 'Tbmp', idbmBall+idGreen, 	"green0191.bin"
	res 'Tbmp', idbmBall+idBlue, 	"blue0192.bin"
	res 'Tbmp', idbmBall+idYellow,	"yellow0193.bin"
	res 'Tbmp', idbmBall+idViolet,	"violet0194.bin"

; 'pref' resource. Defines app launch flags, stack and heap size
	res 'PREF', idrPREF
	dc.w	sysAppLaunchFlagNewStack|sysAppLaunchFlagNewGlobals|sysAppLaunchFlagUIApp|sysAppLaunchFlagSubCall
	dc.l	$1000			; stack size
	dc.l	$1000			; heap size

end
